<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

trait CpuCache {
	#[ORM\Column('l1_count', type:'integer', options: array(
		'comment' => 'The number of L1 caches on the package, usually the same as the number of cores'
	))]
	private int $L1Count = 1;

	#[ORM\Column('l1_data_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 data cache in KB'
	))]
	private ?int $L1dSize;

	#[ORM\Column('l1_code_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 instruction cache in KB'
	))]
	private ?int $L1cSize;

	#[ORM\Column('l1_unified_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 unified cache in KB'
	))]
	private ?int $L1uSize;

	#[ORM\Column('l1_way', type: 'integer', nullable: true)]
	private ?int $L1Way;

	#[ORM\Column('l2_count', type: 'integer', options: array(
		'comment' => 'The number of L2 caches on the package, usually the same as the number of cores'
	))]
	private int $L2Count = 1;

	#[ORM\Column('l2_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 2 cache in KB'
	))]
	private ?int $L2Size;

	#[ORM\Column('l2_way', type: 'integer', nullable: true)]
	private ?int $L2Way;

	#[ORM\Column('l3_count', type: 'integer', options: array(
		'comment' => 'The number of L3 caches on the package'
	))]
	private int $L3Count = 0;

	#[ORM\Column('l3_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 3 cache in KB'
	))]
	private ?int $L3Size;

	#[ORM\Column('l3_way', type: 'integer', nullable: true)]
	private ?int $L3Way;
}
